package listactors

import scala.actors._
import scala.actors.Actor._

case class Register (calculation : Actor)
case class BroadcastMsg (value : Any)



  /**
   * Das Broadcaster Objekt verteilt eine Nachricht an mehrere Empfnger.
   * Der Broadcaster ist ein Actor, an den beliebige Nachrichten geschickt werden knnen,
   * die Nachrichten werden ungendert einfach an alle Empfnger (ebenfalls Actors) 
   * weitergegeben.
   *   
   */


object Broadcaster  extends Actor {

   // Map mit allen registrierten ListCalculations, die Nachrichten empfangen wollen
   private var allReceivers : List [Actor] = List ()
  
   
   def act () {
     
     while (true) {
       
       receive {         
	       case Register(receiver) => allReceivers = receiver :: allReceivers 
		   case BroadcastMsg (value) => allReceivers.foreach( actorElement => actorElement ! value) 
       }
       
       
     }
     
   }    


}



