package listactors

import scala.actors._

case class PartResult  ( data: List[Int ], position : Int )

/**
 * Diese Klasse ist ein Actor, der die Teilergebnisse sammelt. Wenn alle Teileregnisse vorliegen,
 * wird daraus die Gesamtliste gebaut. Die Gesamtliste wird dann an ListCalculations zurckgegeben. 
 * Alternativ knnte man mit println das Ergebnis auch direkt ausgeben.
 */

class ResultCollector (numberOfLists : Integer , listName : String,  notifyOnResult: ListCalculations)  extends Actor {


   val collector = new Array [List[Int]] (numberOfLists);
   var missingResults = numberOfLists;
  
   
   def act () {
     
     while (missingResults > 0) {
       
       receive {         
         case res : PartResult  => { 
            collector(res.position) = res.data ;
            missingResults -= 1
           
         }

       }
  
     }
     
      val fullResult = collector.toList.flatten;
      notifyOnResult ! SetResultList (fullResult , listName)
 
      
      
     
   }    


}